
#ifndef LOADSAVE_H
#define LOADSAVE_H


#define NEWFILE 0xffff

/* Save text pointed by arg to a new memo */
int savetext(char *txtbuf, word *p_fp, int *p_cat);

/* Save text pointed by arg to a new memo and sorts it after prev_fp */
int savetextAt(char *txtbuf, word *p_fp, int *p_cat, word prev_fp );

/* Load a memo to the buffer pointed by arg */
int loadtext(char *txtbuf, char *title, word *p_fp, int *p_cat);

/* search direction for loadpage(): 
   Load next/prev. Memo with same title 
   SEARCH_THIS_PAGE is used to perform no search, but to load the file at *p_fp, this is like a simplyfied LibFileRead(), then also set: title==NULL */
typedef enum { SEARCH_NEXT_PAGE, SEARCH_PREV_PAGE, SEARCH_THIS_PAGE } t_searchdir;

int loadpage(char *txtbuf, char *title, t_searchdir d, word *p_fp, int cat);

/* delete a file */
int deletefile(word fp);

/* this defines the end of the main-title of a memo */
#define IS_TITLE_ENDCHAR(C) (C=='-' || C==':' || C=='(' || C=='\r' || C==0 )

#endif